JUCE: SpinLock Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
SpinLock Class Reference
juce_core » threads

A simple spin-lock class that can be used as a simple, low-overhead mutex for uncontended situations. More...

`#include <juce_SpinLock.h>`

## Public Types
using | ScopedLockType = GenericScopedLock<SpinLock>
| Provides the type of scoped lock to use for locking a SpinLock.
using | ScopedUnlockType = GenericScopedUnlock<SpinLock>
| Provides the type of scoped unlocker to use with a SpinLock.
using | ScopedTryLockType = GenericScopedTryLock<SpinLock>
| Provides the type of scoped try-lock to use for locking a SpinLock.

## Public Member Functions
| SpinLock ()=default
| ~SpinLock ()=default
void | enter () const noexcept
| Acquires the lock.
bool | tryEnter () const noexcept
| Attempts to acquire the lock, returning true if this was successful.
void | exit () const noexcept
| Releases the lock.

## Detailed Description

A simple spin-lock class that can be used as a simple, low-overhead mutex for uncontended situations.

Note that unlike a CriticalSection, this type of lock is not re-entrant, and may be less efficient when used in a highly contended situation, but it's very small and requires almost no initialisation. It's most appropriate for simple situations where you're only going to hold the lock for a very brief time.

See also
  CriticalSection

## Member Typedef Documentation

## ◆ ScopedLockType

using SpinLock::ScopedLockType = GenericScopedLock<SpinLock>

Provides the type of scoped lock to use for locking a SpinLock.

## ◆ ScopedUnlockType

using SpinLock::ScopedUnlockType = GenericScopedUnlock<SpinLock>

Provides the type of scoped unlocker to use with a SpinLock.

## ◆ ScopedTryLockType

using SpinLock::ScopedTryLockType = GenericScopedTryLock<SpinLock>

Provides the type of scoped try-lock to use for locking a SpinLock.

## Constructor & Destructor Documentation

## ◆ SpinLock()

SpinLock::SpinLock | ( |  | ) |
| default

## ◆ ~SpinLock()

SpinLock::~SpinLock | ( |  | ) |
| default

## Member Function Documentation

## ◆ enter()

void SpinLock::enter | ( |  | ) | const
| noexcept

Acquires the lock.

This will block until the lock has been successfully acquired by this thread. Note that a SpinLock is NOT re-entrant, and is not smart enough to know whether the caller thread already has the lock - so if a thread tries to acquire a lock that it already holds, this method will never return!

It's strongly recommended that you never call this method directly - instead use the ScopedLockType class to manage the locking using an RAII pattern instead.

## ◆ tryEnter()

bool SpinLock::tryEnter | ( |  | ) | const
| noexcept

Attempts to acquire the lock, returning true if this was successful.

## ◆ exit()

void SpinLock::exit | ( |  | ) | const
| noexcept

Releases the lock.

References jassert.

The documentation for this class was generated from the following file:

- juce_SpinLock.h